using Adaptation.Shared;
using Adaptation.Shared.Methods;
using System;
using System.Collections.Generic;
using System.Text.Json;
using System.Text.Json.Serialization;

namespace Adaptation.FileHandlers.SECS;

public class Description : IDescription, Shared.Properties.IDescription
{

    public int Test { get; set; }
    public int Count { get; set; }
    public int Index { get; set; }

    public string MesEntity { get; set; }
    public string Date { get; set; }

    [JsonPropertyName("CURRENT_RECIPE_NAME")]
    public string PSN { get; set; } // Part

    [JsonPropertyName("LotID")]
    public string Reactor { get; set; } // Process

    [JsonPropertyName("ID")]
    public string RDS { get; set; } // Lot

    [JsonPropertyName("PATTERNTYPE")]
    public string Recipe { get; set; } // Item descriptor

    [JsonPropertyName("SAMPLETYPE")]
    public string Employee { get; set; } // Item descriptor

    [JsonPropertyName("SLOT_NUMBER")]
    public string SlotNumber { get; set; } // Item descriptor

    string IDescription.GetEventDescription() => "File Has been read and parsed";

    List<string> IDescription.GetNames(IFileRead fileRead, Logistics logistics) =>
        throw new NotImplementedException();

    List<string> IDescription.GetDetailNames() =>
        throw new NotImplementedException();

    List<string> IDescription.GetHeaderNames() =>
        throw new NotImplementedException();

    IDescription IDescription.GetDisplayNames() =>
        throw new NotImplementedException();

    List<string> IDescription.GetParameterNames() =>
        throw new NotImplementedException();

    JsonProperty[] IDescription.GetDefault(IFileRead fileRead, Logistics logistics) =>
        throw new NotImplementedException();

    List<string> IDescription.GetPairedParameterNames() =>
        throw new NotImplementedException();

    List<string> IDescription.GetIgnoreParameterNames(Test test) =>
        throw new NotImplementedException();

    IDescription IDescription.GetDefaultDescription(IFileRead fileRead, Logistics logistics) =>
        throw new NotImplementedException();

    Dictionary<string, string> IDescription.GetDisplayNamesJsonElement(IFileRead fileRead) =>
        throw new NotImplementedException();

    List<IDescription> IDescription.GetDescriptions(IFileRead fileRead, Logistics logistics, List<Test> tests, IProcessData iProcessData) =>
        throw new NotImplementedException();

    internal static string GetDateFormat() => "MM/dd/yyyy HH:mm:ss";

}